/*
    Copyright (C) 2005, 2006  Vansteenhuyse Hubert <hvansteenhuyse@yahoo.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#define LCASE(c)( c >= 'A' && c <= 'Z' ? c - 'A' + 'a' : c )  //lowercase a single (wide) char

void log(char *fmt, ...);
unsigned int htoi(char *value);
void atoh(char ascii, char *outbuf);
char *AsciiXlat(unsigned char ascii);

int needmemory(char **p, unsigned long *plen, unsigned long forcedlen = 0);
void freememory(void* p);

class CStr{
    private:
        char *mBuf;
        unsigned long mSze, mTail;
    protected:

    public:
         CStr(unsigned long bufsze = 0);
         ~CStr();
         void clear();
         char* get();
         char get(unsigned long at);
         void setat(unsigned long at, char ch);
         void del();
         unsigned long getsize();
         int append(const char *str);
         int append(const char c);
         int startsWith(const char* str);
};

